// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.grouping;

import fr.ifremer.adagio.core.dao.referential.pmfm.Pmfm;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Niveau de regroupement, d'une classification donnée.
 * </p>
 * <p>
 * </p>
 * <p>
 * Exemple : pour les métiers, on peut avoir les niveaux de regroupement
 * suivants : arts, grandes familles d’engins, …
 * </p>
 * <p>
 * </p>
 * <p>
 * Un niveau de regroupement peut avoir un niveau parent.
 * </p>
 * <p>
 * </p>
 * <p>
 * Un niveau de regroupement contient un ou plusieurs regroupements (<i>Grouping</i>).
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class GroupingLevel
    implements Serializable, Comparable<GroupingLevel>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -2903166696133835446L;

    // Generate 5 attributes
    private Integer id;

    /**
     * Identifiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Identifiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String label;

    /**
     * 
     * @return this.label String
     */
    public String getLabel()
    {
        return this.label;
    }

    /**
     * 
     * @param labelIn String
     */
    public void setLabel(String labelIn)
    {
        this.label = labelIn;
    }

    private String name;

    /**
     * 
     * @return this.name String
     */
    public String getName()
    {
        return this.name;
    }

    /**
     * 
     * @param nameIn String
     */
    public void setName(String nameIn)
    {
        this.name = nameIn;
    }

    private String description;

    /**
     * 
     * @return this.description String
     */
    public String getDescription()
    {
        return this.description;
    }

    /**
     * 
     * @param descriptionIn String
     */
    public void setDescription(String descriptionIn)
    {
        this.description = descriptionIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 5 associations
    private GroupingLevel parentGroupingLevel;

    /**
     * Le niveau de regroupement parent (optionnel).
     * @return this.parentGroupingLevel GroupingLevel
     */
    public GroupingLevel getParentGroupingLevel()
    {
        return this.parentGroupingLevel;
    }

    /**
     * Le niveau de regroupement parent (optionnel).
     * @param parentGroupingLevelIn GroupingLevel
     */
    public void setParentGroupingLevel(GroupingLevel parentGroupingLevelIn)
    {
        this.parentGroupingLevel = parentGroupingLevelIn;
    }

    private Collection<Grouping> groupings = new HashSet<Grouping>();

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Un regroupement représente un groupement d'entités (du référentiel ou
     * bien de navires), correspondant à un niveau de regroupement donné (<i>GroupingLevel</i>).
     * </p>
     * <p>
     * </p>
     * <p>
     * Un regroupement peut faire référence à une ou plusieurs entités du
     * référentiel (<i>GroupingItem</i>). Généralement, surtout les
     * regroupements de plus bas niveau sont liés à des entités du référentiel
     * (plus facile à maintenir), puis une table technique remplie toutes les
     * associations possible avec les ancêtres (cf <i>GroupingItemHierarchy</i>).
     * </p>
     * <p>
     * </p>
     * <p>
     * Un regroupement peut avoir un regroupement parent.
     * </p>
     * </body>
     * </html>
     * @return this.groupings Collection<Grouping>
     */
    public Collection<Grouping> getGroupings()
    {
        return this.groupings;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Un regroupement représente un groupement d'entités (du référentiel ou
     * bien de navires), correspondant à un niveau de regroupement donné (<i>GroupingLevel</i>).
     * </p>
     * <p>
     * </p>
     * <p>
     * Un regroupement peut faire référence à une ou plusieurs entités du
     * référentiel (<i>GroupingItem</i>). Généralement, surtout les
     * regroupements de plus bas niveau sont liés à des entités du référentiel
     * (plus facile à maintenir), puis une table technique remplie toutes les
     * associations possible avec les ancêtres (cf <i>GroupingItemHierarchy</i>).
     * </p>
     * <p>
     * </p>
     * <p>
     * Un regroupement peut avoir un regroupement parent.
     * </p>
     * </body>
     * </html>
     * @param groupingsIn Collection<Grouping>
     */
    public void setGroupings(Collection<Grouping> groupingsIn)
    {
        this.groupings = groupingsIn;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Un regroupement représente un groupement d'entités (du référentiel ou
     * bien de navires), correspondant à un niveau de regroupement donné (<i>GroupingLevel</i>).
     * </p>
     * <p>
     * </p>
     * <p>
     * Un regroupement peut faire référence à une ou plusieurs entités du
     * référentiel (<i>GroupingItem</i>). Généralement, surtout les
     * regroupements de plus bas niveau sont liés à des entités du référentiel
     * (plus facile à maintenir), puis une table technique remplie toutes les
     * associations possible avec les ancêtres (cf <i>GroupingItemHierarchy</i>).
     * </p>
     * <p>
     * </p>
     * <p>
     * Un regroupement peut avoir un regroupement parent.
     * </p>
     * </body>
     * </html>
     * @param elementToAdd Grouping
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addGroupings(Grouping elementToAdd)
    {
        return this.groupings.add(elementToAdd);
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Un regroupement représente un groupement d'entités (du référentiel ou
     * bien de navires), correspondant à un niveau de regroupement donné (<i>GroupingLevel</i>).
     * </p>
     * <p>
     * </p>
     * <p>
     * Un regroupement peut faire référence à une ou plusieurs entités du
     * référentiel (<i>GroupingItem</i>). Généralement, surtout les
     * regroupements de plus bas niveau sont liés à des entités du référentiel
     * (plus facile à maintenir), puis une table technique remplie toutes les
     * associations possible avec les ancêtres (cf <i>GroupingItemHierarchy</i>).
     * </p>
     * <p>
     * </p>
     * <p>
     * Un regroupement peut avoir un regroupement parent.
     * </p>
     * </body>
     * </html>
     * @param elementToRemove Grouping
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeGroupings(Grouping elementToRemove)
    {
        return this.groupings.remove(elementToRemove);
    }

    private Pmfm pmfm;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Caractéristique définissant le niveau de regroupement (optionnel).
     * </p>
     * <p>
     * Permet un accès au <i>GroupingLevel</i> via requete sur les PSFM,
     * plutot que par les identifiants ou libellés des <i>GroupingLevel</i>.
     * </p>
     * <p>
     * </p>
     * <p>
     * Par exemple :
     * </p>
     * <p>
     * - Longueur d'un navire,
     * </p>
     * <p>
     * - Jauge d'un navire,
     * </p>
     * <p>
     * - etc.
     * </p>
     * </body>
     * </html>
     * @return this.pmfm Pmfm
     */
    public Pmfm getPmfm()
    {
        return this.pmfm;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Caractéristique définissant le niveau de regroupement (optionnel).
     * </p>
     * <p>
     * Permet un accès au <i>GroupingLevel</i> via requete sur les PSFM,
     * plutot que par les identifiants ou libellés des <i>GroupingLevel</i>.
     * </p>
     * <p>
     * </p>
     * <p>
     * Par exemple :
     * </p>
     * <p>
     * - Longueur d'un navire,
     * </p>
     * <p>
     * - Jauge d'un navire,
     * </p>
     * <p>
     * - etc.
     * </p>
     * </body>
     * </html>
     * @param pmfmIn Pmfm
     */
    public void setPmfm(Pmfm pmfmIn)
    {
        this.pmfm = pmfmIn;
    }

    private GroupingClassification groupingClassification;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Une classification de regroupement ne traite que d’un seul type de
     * données du référentiel à la fois (<i>ObjectType</i>).
     * Il peut s’agir de regroupement sur les métiers, les lieux, les espèces,
     * etc.
     * </p>
     * <p>
     * En revanche, un même type de données du référentiel (ex : Métier) peut
     * avoir plusieurs classification de regroupement distinctes (DCR, Ifremer,
     * Natura 2000, …)
     * </p>
     * <p>
     * </p>
     * <p>
     * Une classification de regroupement peut contenir un ou plusieurs niveaux
     * de regroupement (<i>GroupingLevel</i>).
     * </p>
     * </body>
     * </html>
     * @return this.groupingClassification GroupingClassification
     */
    public GroupingClassification getGroupingClassification()
    {
        return this.groupingClassification;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Une classification de regroupement ne traite que d’un seul type de
     * données du référentiel à la fois (<i>ObjectType</i>).
     * Il peut s’agir de regroupement sur les métiers, les lieux, les espèces,
     * etc.
     * </p>
     * <p>
     * En revanche, un même type de données du référentiel (ex : Métier) peut
     * avoir plusieurs classification de regroupement distinctes (DCR, Ifremer,
     * Natura 2000, …)
     * </p>
     * <p>
     * </p>
     * <p>
     * Une classification de regroupement peut contenir un ou plusieurs niveaux
     * de regroupement (<i>GroupingLevel</i>).
     * </p>
     * </body>
     * </html>
     * @param groupingClassificationIn GroupingClassification
     */
    public void setGroupingClassification(GroupingClassification groupingClassificationIn)
    {
        this.groupingClassification = groupingClassificationIn;
    }

    private Collection<GroupingLevel> groupingLevels = new HashSet<GroupingLevel>();

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Niveau de regroupement, d'une classification donnée.
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemple : pour les métiers, on peut avoir les niveaux de regroupement
     * suivants : arts, grandes familles d’engins, …
     * </p>
     * <p>
     * </p>
     * <p>
     * Un niveau de regroupement peut avoir un niveau parent.
     * </p>
     * <p>
     * </p>
     * <p>
     * Un niveau de regroupement contient un ou plusieurs regroupements (<i>Grouping</i>).
     * </p>
     * </body>
     * </html>
     * @return this.groupingLevels Collection<GroupingLevel>
     */
    public Collection<GroupingLevel> getGroupingLevels()
    {
        return this.groupingLevels;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Niveau de regroupement, d'une classification donnée.
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemple : pour les métiers, on peut avoir les niveaux de regroupement
     * suivants : arts, grandes familles d’engins, …
     * </p>
     * <p>
     * </p>
     * <p>
     * Un niveau de regroupement peut avoir un niveau parent.
     * </p>
     * <p>
     * </p>
     * <p>
     * Un niveau de regroupement contient un ou plusieurs regroupements (<i>Grouping</i>).
     * </p>
     * </body>
     * </html>
     * @param groupingLevelsIn Collection<GroupingLevel>
     */
    public void setGroupingLevels(Collection<GroupingLevel> groupingLevelsIn)
    {
        this.groupingLevels = groupingLevelsIn;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Niveau de regroupement, d'une classification donnée.
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemple : pour les métiers, on peut avoir les niveaux de regroupement
     * suivants : arts, grandes familles d’engins, …
     * </p>
     * <p>
     * </p>
     * <p>
     * Un niveau de regroupement peut avoir un niveau parent.
     * </p>
     * <p>
     * </p>
     * <p>
     * Un niveau de regroupement contient un ou plusieurs regroupements (<i>Grouping</i>).
     * </p>
     * </body>
     * </html>
     * @param elementToAdd GroupingLevel
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addGroupingLevels(GroupingLevel elementToAdd)
    {
        return this.groupingLevels.add(elementToAdd);
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Niveau de regroupement, d'une classification donnée.
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemple : pour les métiers, on peut avoir les niveaux de regroupement
     * suivants : arts, grandes familles d’engins, …
     * </p>
     * <p>
     * </p>
     * <p>
     * Un niveau de regroupement peut avoir un niveau parent.
     * </p>
     * <p>
     * </p>
     * <p>
     * Un niveau de regroupement contient un ou plusieurs regroupements (<i>Grouping</i>).
     * </p>
     * </body>
     * </html>
     * @param elementToRemove GroupingLevel
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeGroupingLevels(GroupingLevel elementToRemove)
    {
        return this.groupingLevels.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an GroupingLevel instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof GroupingLevel))
        {
            return false;
        }
        final GroupingLevel that = (GroupingLevel)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link GroupingLevel}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link GroupingLevel}.
         * @return new GroupingLevelImpl()
         */
        public static GroupingLevel newInstance()
        {
            return new GroupingLevelImpl();
        }

        /**
         * Constructs a new instance of {@link GroupingLevel}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param label String
         * @param name String
         * @param groupingClassification GroupingClassification
         * @return newInstance
         */
        public static GroupingLevel newInstance(String label, String name, GroupingClassification groupingClassification)
        {
            final GroupingLevel entity = new GroupingLevelImpl();
            entity.setLabel(label);
            entity.setName(name);
            entity.setGroupingClassification(groupingClassification);
            return entity;
        }

        /**
         * Constructs a new instance of {@link GroupingLevel}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param label String
         * @param name String
         * @param description String
         * @param updateDate Timestamp
         * @param parentGroupingLevel GroupingLevel
         * @param groupings Collection<Grouping>
         * @param pmfm Pmfm
         * @param groupingClassification GroupingClassification
         * @param groupingLevels Collection<GroupingLevel>
         * @return newInstance GroupingLevel
         */
        public static GroupingLevel newInstance(String label, String name, String description, Timestamp updateDate, GroupingLevel parentGroupingLevel, Collection<Grouping> groupings, Pmfm pmfm, GroupingClassification groupingClassification, Collection<GroupingLevel> groupingLevels)
        {
            final GroupingLevel entity = new GroupingLevelImpl();
            entity.setLabel(label);
            entity.setName(name);
            entity.setDescription(description);
            entity.setUpdateDate(updateDate);
            entity.setParentGroupingLevel(parentGroupingLevel);
            entity.setGroupings(groupings);
            entity.setPmfm(pmfm);
            entity.setGroupingClassification(groupingClassification);
            entity.setGroupingLevels(groupingLevels);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(GroupingLevel o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getLabel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getLabel().compareTo(o.getLabel()));
            }
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.getDescription() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDescription().compareTo(o.getDescription()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// GroupingLevel.java merge-point
}